// desk.cpp


#define _TRACE_OFF_


#include <windows.h>
#include "desk.h"
#include "ini.h"

DESK::DESK()
{
}

DESK::~DESK()
{
}

void DESK::Init(HWND hwnd)
{
	hWnd				= hwnd;
	int desk_width		= GetSystemMetrics(SM_CXSCREEN);/*fXNgbv̕*/
	int desk_height		= GetSystemMetrics(SM_CYSCREEN);/*fXNgbv̍*/
	back.Clear(ini.bk_rgb, desk_width, desk_height);
	if (lstrlen(ini.back_fname)>0)
		ChangeTile(ini.back_fname);
	back_sv.Copy(&back);
	PasteBackImg();
	desk.Resize(desk_width, desk_height);
	desk.Copy(&back);
}

void DESK::Clear()
{
	PasteBackImg();
	desk.Copy(&back);
}

BOOL DESK::ChangeRGB()
{
	CHOOSECOLOR		cc;
	static DWORD	cust[16]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

	cc.lStructSize		= sizeof(cc);
	cc.hwndOwner		= hWnd;
	cc.hInstance		= NULL;
	cc.rgbResult		= ini.bk_rgb;
	cc.lpCustColors		= cust;
	cc.Flags			= CC_RGBINIT;
	cc.lCustData		= 0;
	cc.lpfnHook			= NULL;
	cc.lpTemplateName	= "";
	if (ChooseColor(&cc)==TRUE) {
		ini.bk_rgb			= cc.rgbResult;
		ini.back_fname[0]	= '\0';
		back.Clear(ini.bk_rgb);
		back_sv.Copy(&back);
		PasteBackImg();
		return(TRUE);
	}
	return(FALSE);
}

void DESK::ChangeTile(char * name)
{
	MYBIT	temp;
	int		x, y;

	lstrcpy(ini.back_fname, name);
	HINSTANCE	hInst= (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);
	if (temp.ReadDIB(name, hInst)==FALSE) {
		ini.back_fname[0]	= '\0';
		return;
	}
	for (y=0; y<back.GetH(); y+=temp.GetH()) {
		for (x=0; x<back.GetW(); x+=temp.GetW()) {
			back.Paste(&temp, x, y);
		}
	}
	back_sv.Copy(&back);
	PasteBackImg();
}

void DESK::SetBackImg(MYBIT *img)
{
	double		L, H, S;
	COLORREF	rgb, *p;
	int			i;

	if (ini.guide_back==FALSE) {
		ResetBackImg();
		return;
	}
	back_img.Copy(img);
	for (i=0; i<back_img.GetSize(); i++) {
		p		= back_img.GetC() + i;
		rgb		= *p;
		RGBtoLHS(rgb, &L, &H, &S);
		S		= S * 0.1;
		L		= L * 0.5 + 50;
		rgb		= LHStoRGB(L, H, S);
		*p		= rgb;
	}
	PasteBackImg();
}

void DESK::ResetBackImg()
{
	back_img.Reset();
	back.Copy(&back_sv);
}

void DESK::PasteBackImg()
{
	RECT	r;
	int		x, y;

	if (back_img.GetSize()==0)
		return;
	GetClientRect(hWnd, &r);
	x	= ( r.right  - back_img.GetW() ) / 2;
	y	= ( r.bottom - back_img.GetH() ) / 2;
	back.Paste(&back_img, x, y);
}


