#define		_MYBIT_CPP_

#include <windows.h>
#include <math.h>
#include "mybit.h"
#include "ini.h"
#include "win_err_msg.h"

extern HWND main_hWnd;//eXgp

BOOL     jpeg_get_image(char *fname, COLORREF **buf, int *w, int *h, int denom, int check_only);

void trace(char *str)
{
	static DWORD	time_new=0;
	DWORD			time_old=time_new;
	char	s[1000], fname[MAX_PATH];
	HANDLE	hF;
	DWORD	dwResult;

	if (trace_flg==FALSE)
		return;
	wsprintf(fname,"%s%s", ini.exe_dir, "\\trace.txt");
	if (time_new==0) {
		DeleteFile(fname);
		time_old	= GetTickCount();
	}
	time_new	= GetTickCount();
	wsprintf(s, "%6d %s\n", (time_new-time_old), str);
	hF		= CreateFile(fname, GENERIC_WRITE, 0, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	SetFilePointer(hF, 0, 0, FILE_END);
	WriteFile(hF, s, lstrlen(s), &dwResult, NULL);
	CloseHandle(hF);
}

void* mem_alloc(int size)
{
	char *buf;

	buf	= (char*)GlobalAlloc(GMEM_FIXED, size);
	return((void*)buf);

}

MYBIT::MYBIT()
{
	ZeroMemory (&bf, sizeof(bf));
	ZeroMemory (&bh, sizeof(bh));
	c					= NULL;
	size				= 0;
	((char*)(&bf))[0]	= 'B';
	((char*)(&bf))[1]	= 'M';
	bf.bfSize			= 0;
	bf.bfOffBits		= sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
	bh.biSize			= sizeof(BITMAPINFOHEADER);
	bh.biWidth			= 0;
	bh.biHeight			= 0;
	bh.biPlanes			= 1;
	bh.biBitCount		= 32;
	bh.biCompression	= BI_RGB;
}

MYBIT::~MYBIT()
{
	Reset();
}

//NAiO̎c[̌nj
void MYBIT::Reset()
{
	if (c!=NULL) {
		GlobalFree(c);
		c			= NULL;
	}
	size		= 0;
	bf.bfSize	= 0;
	bh.biWidth	= 0;
	bh.biHeight	= 0;
}

BOOL MYBIT::Load_Image(char *fname, HINSTANCE hInstance)
{
	BITMAP		 	bmp_info;
	COLORREF		*pBIT;

	HBITMAP hBIT1 = (HBITMAP)LoadImage(hInstance, fname, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
	if (hBIT1 == NULL) {
		char s[256];
		wsprintf(s, "ǂݍ݂ł܂B\n%s", fname);
		MessageBox(NULL, s, "C[WǍs", MB_OK);
		return(FALSE);
	}
	GetObject(hBIT1, sizeof(BITMAP), &bmp_info);

	size				= bmp_info.bmWidth * bmp_info.bmHeight;
	bf.bfSize			= sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + size*4;
	bh.biWidth			= bmp_info.bmWidth;
	bh.biHeight			= bmp_info.bmHeight;
	c					= (COLORREF*)GlobalAlloc(GMEM_FIXED, size*4);

	HBITMAP hBIT2		= CreateDIBSection(NULL, (LPBITMAPINFO)&bh, DIB_RGB_COLORS, (VOID**)&pBIT, NULL, 0);
	HDC hDC1			= CreateCompatibleDC(NULL);
	HDC hDC2			= CreateCompatibleDC(NULL);
	HBITMAP hBIT1_org	= (HBITMAP)SelectObject(hDC1, hBIT1);
	HBITMAP hBIT2_org	= (HBITMAP)SelectObject(hDC2, hBIT2);
	BitBlt(hDC2, 0, 0, bmp_info.bmWidth, bmp_info.bmHeight, hDC1, 0, 0, SRCCOPY);

	SelectObject(hDC1, hBIT1_org);
	SelectObject(hDC2, hBIT2_org);
	DeleteDC(hDC1);
	DeleteDC(hDC2);

	CopyMemory (c, pBIT, size*4);

	DeleteObject(hBIT1);
	DeleteObject(hBIT2);
	return(TRUE);
}

//bmpt@Ĉ܂ܓǂ(BITMAPFILEHEADER{BITMAPINFOHEADER{rbg)
BOOL MYBIT::ReadDIB(char *fname, HINSTANCE hInstance, int jpeg_denom)
{
	BITMAPFILEHEADER	w_bf;
	BITMAPINFOHEADER	w_bh;
	DWORD				dwResult;
	unsigned char		wk[2];

	Reset();

	HANDLE hF = CreateFile(fname, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hF == INVALID_HANDLE_VALUE) {
		win_err_msg((LPTSTR)"CreateFile", (LPTSTR)fname);
		return(FALSE);
	}
	ReadFile(hF, &w_bf, sizeof(BITMAPFILEHEADER), &dwResult, NULL);

	//bmp`łȂjpegƂ݂Ȃjpeg_get_imageœ͂
	CopyMemory (&wk, &w_bf, 2);
	if (wk[0]!='B' && wk[1]!='M') {
		CloseHandle(hF);
		int		w, h;

		if (jpeg_get_image(fname, &c, &w, &h, jpeg_denom, FALSE)==FALSE) {
			char s[256];
			wsprintf(s, "ǂݍ݂ł܂B\n%s", fname);
			MessageBox(NULL, s, "C[WǍs", MB_OK);
			return(FALSE);
		}
		bh.biWidth	= w;
		bh.biHeight	= h;
		size		= bh.biWidth * bh.biHeight;
		return(TRUE);
	}

	ReadFile(hF, &w_bh, sizeof(BITMAPINFOHEADER), &dwResult, NULL);

	//32rbgBMPȊOȂLoad_Imageœ͂
	if (w_bh.biBitCount!=32) {
		CloseHandle(hF);
		return(MYBIT::Load_Image(fname, hInstance));
	}

	bf		= w_bf;
	bh		= w_bh;
	size	= (bf.bfSize - sizeof(BITMAPFILEHEADER) - sizeof(BITMAPINFOHEADER)) / 4;
	c		= (COLORREF*)GlobalAlloc(GMEM_FIXED, size*4);

	ReadFile(hF, c, size*4, &dwResult, NULL);
	CloseHandle(hF);
	return(TRUE);
}

BOOL MYBIT::ReadDIBS(char *fname, HINSTANCE hInstance, int size)
{
	int		w, h;
	MYBIT	temp;

	temp.ReadWH(fname, hInstance, &w, &h);
	if (w>h) {
		if (w/8>=size)
			temp.ReadDIB(fname, hInstance, 4);
		else
		if (w/4>=size)
			temp.ReadDIB(fname, hInstance, 2);
		else
			temp.ReadDIB(fname, hInstance, 1);
	}
	else {
		if (h/8>=size)
			temp.ReadDIB(fname, hInstance, 4);
		else
		if (h/4>=size)
			temp.ReadDIB(fname, hInstance, 2);
		else
			temp.ReadDIB(fname, hInstance, 1);
	}
	if (temp.GetW()==0 || temp.GetH()==0) {
		temp.Clear(RGB(0,0,0), size, size);
	}
	if (temp.GetW()>temp.GetH()) {
		w	= size;
		h	= temp.GetH() * size / temp.GetW();
	}
	else {
		h	= size;
		w	= temp.GetW() * size / temp.GetH();
	}
	Stretch(&temp, w, h);
	return(TRUE);
}

//width,height𒲂ׂ
BOOL MYBIT::ReadWH(char *fname, HINSTANCE hInstance, int *w, int *h)
{
	if (hInstance==NULL) ;//[jObZ[W߂̖ʂȃR[fBO

	BITMAPFILEHEADER	w_bf;
	BITMAPINFOHEADER	w_bh;
	DWORD				dwResult;
	unsigned char		wk[2];

	Reset();

	HANDLE hF = CreateFile(fname, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hF == INVALID_HANDLE_VALUE) {
		return(FALSE);
	}
	ReadFile(hF, &w_bf, sizeof(BITMAPFILEHEADER), &dwResult, NULL);

	//bmp`łȂjpegƂ݂Ȃjpeg_get_imageœ͂
	CopyMemory (&wk, &w_bf, 2);
	if (wk[0]!='B' && wk[1]!='M') {
		CloseHandle(hF);
		jpeg_get_image(fname, &c, w, h, 1, TRUE);
		return(TRUE);
	}

	ReadFile(hF, &w_bh, sizeof(BITMAPINFOHEADER), &dwResult, NULL);

	*w		= w_bh.biWidth;
	*h		= w_bh.biHeight;

	CloseHandle(hF);
	return(TRUE);
}

//bmpt@C쐬(BITMAPFILEHEADER{BITMAPINFOHEADER{rbg)
void MYBIT::WriteDIB(char *fname)
{
	DWORD	dwResult;

	DeleteFile(fname);
	HANDLE hF = CreateFile(fname, GENERIC_WRITE, 0, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	WriteFile(hF, &bf, sizeof(BITMAPFILEHEADER), &dwResult, NULL);
	WriteFile(hF, &bh, sizeof(BITMAPINFOHEADER), &dwResult, NULL);
	WriteFile(hF, c,   size*4,                   &dwResult, NULL);
	CloseHandle(hF);
}

//hWndɕ\
void MYBIT::Display(int x, int y, HWND hWnd)
{
	TRACE((s,"MYBIT::DIsplay(1) x=%d y=%d w=%d h=%d",x,y,bh.biWidth,bh.biHeight))
	HDC hdc		= GetDC(hWnd);
	SetDIBitsToDevice(hdc,
						x, y,					//]W
						bh.biWidth,				//
						bh.biHeight,			//
						0, 0,					//]W
						0,						//Jnԍ
						bh.biHeight,			//̖{
						c,						//rbg}bvf[^JñAhX
						(LPBITMAPINFO)(&bh),	//BITMAPINFO\̂ւ̃|C^
						DIB_RGB_COLORS);
	ReleaseDC(hWnd, hdc);
}

//hDCɕ\
void MYBIT::Display(int x, int y, HDC hDC)
{
	TRACE((s,"MYBIT::DIsplay(2) x=%d y=%d w=%d h=%d",x,y,bh.biWidth,bh.biHeight))
	SetDIBitsToDevice(hDC,
						x, y,					//]W
						bh.biWidth,				//
						bh.biHeight,			//
						0, 0,					//]W
						0,						//Jnԍ
						bh.biHeight,			//̖{
						c,						//rbg}bvf[^JñAhX
						(LPBITMAPINFO)(&bh),	//BITMAPINFO\̂ւ̃|C^
						DIB_RGB_COLORS);
}

//fXNgbvʂx,y,w,h̃sNZ؂
void MYBIT::CutDesktop(int x, int y, int w, int h)
{
	COLORREF			*pBIT;

	Reset();

	size				= w * h;
	c					= (COLORREF*)GlobalAlloc(GMEM_FIXED, size*4);
	ZeroMemory (c, size*4);
	bf.bfSize			= sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + size*4;
	bh.biWidth			= w;
	bh.biHeight			= h;

	HBITMAP hBIT		= CreateDIBSection(NULL, (LPBITMAPINFO)&bh, DIB_RGB_COLORS, (VOID**)&pBIT, NULL, 0);
	HDC hDC				= CreateCompatibleDC(NULL);
	HBITMAP hBIT_org	= (HBITMAP)SelectObject(hDC, hBIT);
	HDC hDC_desk		= GetDC(NULL);
	BitBlt(hDC, 0, 0, w, h, hDC_desk, x, y, SRCCOPY);
	ReleaseDC(NULL, hDC_desk);
	SelectObject(hDC, hBIT_org);
	DeleteDC(hDC);

	CopyMemory (c, pBIT, size*4);

	DeleteObject(hBIT);
}

//c1œhԂic2͋Ej
void MYBIT::FillB(int x, int y,  COLORREF c1, COLORREF c2)
{
	COLORREF			*pBIT;
	
	HBITMAP hBIT		= CreateDIBSection(NULL, (LPBITMAPINFO)&bh, DIB_RGB_COLORS, (VOID**)&pBIT, NULL, 0);
	CopyMemory (pBIT, c, size*4);
	HDC hDC				= CreateCompatibleDC(NULL);
	HBITMAP hBIT_org	= (HBITMAP)SelectObject(hDC, hBIT);
	HBRUSH hBrush		= CreateSolidBrush(c1);
	HBRUSH hBrush_org	= (HBRUSH)SelectObject(hDC, hBrush);

	ExtFloodFill(hDC, x, y, c2, FLOODFILLBORDER);

	SelectObject(hDC, hBIT_org);
	SelectObject(hDC, hBrush_org);
	DeleteDC(hDC);
	CopyMemory (c, pBIT, size*4);

	DeleteObject(hBIT);
	DeleteObject(hBrush);
}
	
//c1œhԂic2uj
void MYBIT::FillS(int x, int y,  COLORREF c1, COLORREF c2)
{
	COLORREF			*pBIT;
	
	HBITMAP hBIT		= CreateDIBSection(NULL, (LPBITMAPINFO)&bh, DIB_RGB_COLORS, (VOID**)&pBIT, NULL, 0);
	CopyMemory (pBIT, c, size*4);
	HDC hDC				= CreateCompatibleDC(NULL);
	HBITMAP hBIT_org	= (HBITMAP)SelectObject(hDC, hBIT);
	HBRUSH hBrush		= CreateSolidBrush(c1);
	HBRUSH hBrush_org	= (HBRUSH)SelectObject(hDC, hBrush);

	ExtFloodFill(hDC, x, y, c2, FLOODFILLSURFACE);

	SelectObject(hDC, hBIT_org);
	SelectObject(hDC, hBrush_org);
	DeleteDC(hDC);
	CopyMemory (c, pBIT, size*4);

	DeleteObject(hBIT);
	DeleteObject(hBrush);
}

//c1ŃxWGȐ
void MYBIT::BZline(BZ bzt[],  COLORREF c1)
{
	COLORREF			*pBIT;
	int					i;

	HBITMAP hBIT		= CreateDIBSection(NULL, (LPBITMAPINFO)&bh, DIB_RGB_COLORS, (VOID**)&pBIT, NULL, 0);
	CopyMemory (pBIT, c, size*4);
	HDC hDC				= CreateCompatibleDC(NULL);
	HBITMAP hBIT_org	= (HBITMAP)SelectObject(hDC, hBIT);
	HPEN hPen			= CreatePen(PS_SOLID, 1, c1);
	HPEN hPen_org		= (HPEN)SelectObject(hDC, hPen);

	for (i=0; (bzt[i].num)!=0; i++) {
		PolyBezier(hDC, bzt[i].bz, bzt[i].num);
	}

	SelectObject(hDC, hBIT_org);
	SelectObject(hDC, hPen_org);
	DeleteDC(hDC);
	CopyMemory (c, pBIT, size*4);

	DeleteObject(hBIT);
	DeleteObject(hPen);
}

//c1Œ
void MYBIT::Line(int x0, int y0, int x1, int y1, COLORREF c1)
{
	COLORREF			*pBIT;
	POINT				p_old;

	HBITMAP hBIT		= CreateDIBSection(NULL, (LPBITMAPINFO)&bh, DIB_RGB_COLORS, (VOID**)&pBIT, NULL, 0);
	CopyMemory (pBIT, c, size*4);
	HDC hDC				= CreateCompatibleDC(NULL);
	HBITMAP hBIT_org	= (HBITMAP)SelectObject(hDC, hBIT);
	HPEN hPen			= CreatePen(PS_SOLID, 1, c1);
	HPEN hPen_org		= (HPEN)SelectObject(hDC, hPen);

	MoveToEx(hDC, x0, y0, &p_old);
	LineTo(hDC, x1, y1);

	SelectObject(hDC, hBIT_org);
	SelectObject(hDC, hPen_org);
	DeleteDC(hDC);
	CopyMemory (c, pBIT, size*4);

	DeleteObject(hBIT);
	DeleteObject(hPen);
}

//w,h̑傫ɂ
void MYBIT::Stretch(MYBIT *src, int w, int h)
{
	COLORREF			*pBIT_src, *pBIT_dst;

	Resize(w, h);
	HBITMAP hBIT_src = CreateDIBSection(NULL, (LPBITMAPINFO)src->GetBh(), DIB_RGB_COLORS, (VOID**)&pBIT_src, NULL, 0);
	HBITMAP hBIT_dst = CreateDIBSection(NULL, (LPBITMAPINFO)&bh,          DIB_RGB_COLORS, (VOID**)&pBIT_dst, NULL, 0);
	CopyMemory (pBIT_src, src->GetC(), src->GetSize()*4);

	HDC hDC_src			= CreateCompatibleDC(NULL);
	HDC hDC_dst			= CreateCompatibleDC(NULL);
	HBITMAP hBIT_org_s	= (HBITMAP)SelectObject(hDC_src, hBIT_src);
	HBITMAP hBIT_org_d	= (HBITMAP)SelectObject(hDC_dst, hBIT_dst);

	SetStretchBltMode(hDC_dst, HALFTONE);
	StretchBlt(hDC_dst, 0, 0, w, h, hDC_src, 0, 0, src->GetW(), src->GetH(), SRCCOPY);
	CopyMemory (c, pBIT_dst, size*4);

	SelectObject(hDC_src, hBIT_org_s);
	SelectObject(hDC_dst, hBIT_org_d);
	DeleteDC(hDC_src);
	DeleteDC(hDC_dst);
	DeleteObject(hBIT_src);
	DeleteObject(hBIT_dst);
}

//w,h̑傫ɂ
void MYBIT::Stretch(int w, int h)
{
	MYBIT	temp;

	temp.Copy(this);
	Stretch(&temp, w, h);
}

//\
void MYBIT::Text(char *str, RECT r, COLORREF tx, COLORREF bk)
{
	COLORREF			*pBIT;

	HBITMAP hBIT = CreateDIBSection(NULL, (LPBITMAPINFO)&bh, DIB_RGB_COLORS, (VOID**)&pBIT, NULL, 0);
	CopyMemory (pBIT, c, size*4);
	HDC hDC		= CreateCompatibleDC(NULL);
	HBITMAP hBIT_org	= (HBITMAP)SelectObject(hDC, hBIT);
	SetTextColor(hDC, tx);
	SetBkColor(hDC, bk);
	DrawText(hDC, str, -1, &r, DT_CENTER);
	CopyMemory (c, pBIT, size*4);
	SelectObject(hDC, hBIT_org);
	DeleteDC(hDC);
	DeleteObject(hBIT);
}

//srcsrc_x,src_y,w,h̃sNZ؂
void MYBIT::Cut(MYBIT *src, int src_x, int src_y, int w, int h)
{
	RECT		r1, r2, r3;
	int			dst_y;
	COLORREF	*src_p, *dst_p;

	Reset();

	//src͈̔
	r1.left		= 0;
	r1.top		= 0;
	r1.right	= src->GetW();
	r1.bottom	= src->GetH();
	//Ώ۔͈
	r2.left		= src_x;
	r2.top		= src_y;
	r2.right	= r2.left + w;
	r2.bottom	= r2.top  + h;
	//srcƑΏ۔͈͂̌߂
	IntersectRect(&r3, &r1, &r2);
	if (r3.left==0 && r3.top==0 && r3.right==0 && r3.bottom==0)
		return;
	//src_x,src_y,w,hɕ␳
	src_x		= r3.left;
	src_y		= r3.top;
	w			= r3.right  - r3.left;
	h			= r3.bottom - r3.top;

	size				= w * h;
	c					= (COLORREF*)GlobalAlloc(GMEM_FIXED, size*4);
	ZeroMemory (c, size*4);
	bf.bfSize			= sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + size*4;
	bh.biWidth			= w;
	bh.biHeight			= h;

	src_y = src->GetH()  - src_y - 1;
	dst_y = h            - 0     - 1;
	src_p = src->GetC() + (src_y * src->GetW()) + src_x;
	dst_p = c           + (dst_y * w          ) + 0;

	while (h>0) {
		CopyMemory (dst_p, src_p, w*4);
		src_p -= src->GetW();
		dst_p -= w;
		h--;
	}
}

//srcRs[îɂȂj
void MYBIT::Copy(MYBIT *src)
{
	Reset();
	size				= src->GetW() * src->GetH();
	bf.bfSize			= sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + size*4;
	bh.biWidth			= src->GetW();
	bh.biHeight			= src->GetH();
	c					= (COLORREF*)GlobalAlloc(GMEM_FIXED, size*4);
	CopyMemory (c, src->GetC(), size*4);
}

//wFœhԂ
void MYBIT::Clear(COLORREF color)
{
	int			i;
	COLORREF	col;

	col	= RGB( GetBValue(color), GetGValue(color), GetRValue(color) );		//ԂƐւ
	for (i=0; i<size; i++) {
		c[i]	= col;
	}
}

//w̑傫ōč쐬ēhԂ
void MYBIT::Clear(COLORREF color, int w, int h)
{
	Reset();
	size				= w * h;
	bf.bfSize			= sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + size*4;
	bh.biWidth			= w;
	bh.biHeight			= h;
	c					= (COLORREF*)GlobalAlloc(GMEM_FIXED, size*4);
	MYBIT::Clear(color);
}

//w̑傫ōč쐬čœhԂ
void MYBIT::Resize(int w, int h)
{
	Reset();
	size				= w * h;
	bf.bfSize			= sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + size*4;
	bh.biWidth			= w;
	bh.biHeight			= h;
	c					= (COLORREF*)GlobalAlloc(GMEM_FIXED, size*4);
	ZeroMemory (c, size*4);
}

//dst_x,dst_ÿʒusrc\t(srcAlphallȂ)
void MYBIT::Paste(MYBIT *src, int dst_x, int dst_y)
{
	int				src_x, src_y, w, h;
	COLORREF		*src_p, *dst_p;

	src_x	= 0;
	src_y	= 0;
	w		= src->GetW();
	h		= src->GetH();
	if (Hosei(this, &dst_x, &dst_y, src, &src_x, &src_y, &w, &h)==FALSE)
		return;

	src_y = src->GetH() - src_y - 1;
	dst_y = GetH()      - dst_y - 1;
	src_p = src->GetC() + (src_y * src->GetW()) + src_x;
	dst_p = GetC()      + (dst_y * GetW()     ) + dst_x;

	while (h>0) {
		CopyMemory(dst_p, src_p, w*4);
		src_p -= src->GetW();
		dst_p -= GetW();
		h--;
	}
}

//dst_x,dst_ÿʒusrc\t(srcAlphall)
void MYBIT::PasteA(MYBIT *src, int dst_x, int dst_y)
{
	int				src_x, src_y, w, h;
	COLORREF		*src_p, *dst_p, wp, *src_pp, *dst_pp, src_c, dst_c;
	COLORREF		src_c0, src_c1, src_c2;
	COLORREF		dst_c0, dst_c1, dst_c2;
	COLORREF		src_a, dst_a;
	unsigned int	i;

	src_x	= 0;
	src_y	= 0;
	w		= src->GetW();
	h		= src->GetH();
	if (Hosei(this, &dst_x, &dst_y, src, &src_x, &src_y, &w, &h)==FALSE)
		return;

	src_y = src->GetH() - src_y - 1;
	dst_y = GetH()      - dst_y - 1;
	src_p = src->GetC() + (src_y * src->GetW()) + src_x;
	dst_p = GetC()      + (dst_y * GetW()     ) + dst_x;

	while (h>0) {
		src_pp	= src_p;
		dst_pp	= dst_p;
		for (i=0; i<(unsigned int)w; i++) {
			src_c	= *src_pp;
			src_a	= src_c >> 24;
			if (src_a==255) {
				*dst_pp 	= *src_pp;
			}
			else if (src_a!=0) {
				src_c0	= (unsigned char)src_c;
				src_c1	= (unsigned char)(src_c>>8);
				src_c2	= (unsigned char)(src_c>>16);
				dst_c	= *dst_pp;
				dst_c0	= (unsigned char)dst_c;
				dst_c1	= (unsigned char)(dst_c>>8);
				dst_c2	= (unsigned char)(dst_c>>16);
				dst_a	= 255 - src_a;
				dst_c0	= ( dst_a * dst_c0 + src_a * src_c0 ) >> 8;
				dst_c1	= ( dst_a * dst_c1 + src_a * src_c1 ) >> 8;
				dst_c2	= ( dst_a * dst_c2 + src_a * src_c2 ) >> 8;
				*dst_pp	= dst_c2 << 16 | dst_c1 << 8 | dst_c0;
			}
			src_pp++;
			dst_pp++;
		}
		src_p -= src->GetW();
		dst_p -= GetW();
		h--;
	}
}

//bufƓ̂TRUEԂibuf͏̃rbg}bvł͂ݏoȂƁj
BOOL MYBIT::Find(MYBIT *buf)
{
	COLORREF	*p1, *p2, *p3, *p4;
	int			x, y, y3;
	BOOL		sw;

	for (x=0; x<=bh.biWidth - buf->GetW(); x++) {		//ɌĂ
		p1	= c           + x;
		p2	= buf->GetC();
		for (y=0; y<=bh.biHeight - buf->GetH(); y++) {	//cɌĂ
			if (memcmp(p1, p2, buf->GetW()*4)==0) {		//Psڂv邩
				p3	= p1 + bh.biWidth;
				p4	= p2 + buf->GetW();
				sw	= TRUE;
				for (y3=1; y3<buf->GetH(); y3++) {
					if (memcmp(p3, p4, buf->GetW()*4)!=0) {		//̍sv邩
						sw	= FALSE;
						break;
					}
					p3	= p3 + bh.biWidth;
					p4	= p4 + buf->GetW();
				}
				if (sw==TRUE)
					return(TRUE);			//Ssv
			}
			else
				p1 += bh.biWidth;
		}
	}
	return(FALSE);
}

//łTRUEԂ
BOOL MYBIT::Equal(MYBIT *buf)
{
	if (size!=buf->GetSize())
		return(FALSE);

	if (memcmp(c, buf->GetC(), size*4)==0)
		return(TRUE);
	else
		return(FALSE);
}

//OR color
void MYBIT::OR(COLORREF color)
{
	int		i;

	for (i=0; i<size; i++) {
		c[i]	= c[i] | color;
	}
}

//AND color
void MYBIT::AND(COLORREF color)
{
	int		i;

	for (i=0; i<size; i++) {
		c[i]	= c[i] & color;
	}
}

//vZisrcx,y,w,hdstx,yɃRs[邽߂̍ŏ͈̔͂߂j
BOOL MYBIT::Hosei(MYBIT *dst, int *dst_x, int *dst_y, MYBIT *src, int *src_x, int *src_y, int *w, int *h)
{
	RECT	r1, r2, r3, r4, r5;
	int		dx, dy;

//	TRACE((s,"MYBIT::Hosei BEGIN dst_w=%d dst_h=%d dst_x=%d dst_y=%d src_w=%d src_h=%d src_x=%d src_y=%d w=%d h=%d",dst->GetW(),dst->GetH(),*dst_x,*dst_y,src->GetW(),src->GetH(),*src_x,*src_y,*w,*h))
	//srcdst̂
	dx			= (*dst_x) - (*src_x);
	dy			= (*dst_y) - (*src_y);
	//dst͈̔
	r1.left		= 0;
	r1.top		= 0;
	r1.right	= dst->GetW();
	r1.bottom	= dst->GetH();
	//src͈̔́idst̍_ŎZoj
	r2.left		= dx;
	r2.top		= dy;
	r2.right	= r2.left + src->GetW();
	r2.bottom	= r2.top  + src->GetH();
	//dstsrč߂
	IntersectRect(&r3, &r1, &r2);
	if (r3.left==0 && r3.top==0 && r3.right==0 && r3.bottom==0) {
		TRACE((s,"MYBIT::Hosei(FALSE-1)"))
		return(FALSE);
	}
	//Ώ۔͈
	r4.left		= (*dst_x);
	r4.top		= (*dst_y);
	r4.right	= r4.left + (*w);
	r4.bottom	= r4.top  + (*h);
	//srcdstƑΏ۔͈͂̌߂
	IntersectRect(&r5, &r3, &r4);
	if (r5.left==0 && r5.top==0 && r5.right==0 && r5.bottom==0) {
		TRACE((s,"MYBIT::Hosei(FALSE-2)"))
		return(FALSE);
	}
	//dst_x,dst_y,src_x,src_y,w,hԂ
	*dst_x		= r5.left;
	*dst_y		= r5.top;
	*src_x		= r5.left - dx;
	*src_y		= r5.top  - dy;
	*w			= r5.right  - r5.left;
	*h			= r5.bottom - r5.top;
//	TRACE((s,"MYBIT::Hosei TRUE  dst_w=%d dst_h=%d dst_x=%d dst_y=%d src_w=%d src_h=%d src_x=%d src_y=%d w=%d h=%d",dst->GetW(),dst->GetH(),*dst_x,*dst_y,src->GetW(),src->GetH(),*src_x,*src_y,*w,*h))
	return(TRUE);
}

//p0̎̎̓_𒲂ׂ
BOOL MYBIT::Inside(POINT *p0, COLORREF c0)
{
	const	int			dx[8]={+0,-1,-1,-1,+0,+1,+1,+1};	//ɒׂ
			  		        //          E E E
	const	int			dy[8]={-1,-1,+0,+1,+1,+1,+0,-1};
					        //            
	static	int			i=0;
	POINT				p;
	int					n, w, h;
	COLORREF			*c1;

	w	= GetW();
	h	= GetH();
	//c0Eɖ߂
	for (n=0; n<8; n++) {
		p.x			= p0->x + dx[i];
		p.y			= p0->y + dy[i];
		if (p.x<0 || p.y<0 || p.x>=w || p.y>=h)
			;
		else {
			c1		= c + (h - p.y - 1) * w + p.x;
			if ( *c1==c0 )
				break;
		}
		i			= i + 7;
		i			= i % 8;
	}
	if (n>=8)
		return(FALSE);
	//c0ɒT
	for (n=0; n<8; n++) {
		i++;
		i			= i % 8;
		p.x			= p0->x + dx[i];
		p.y			= p0->y + dy[i];
		if (p.x<0 || p.y<0 || p.x>=w || p.y>=h)
			;
		else {
			c1		= c + (h - p.y - 1) * w + p.x;
			if ( *c1==c0 )
				break;
		}
	}
	if (n>=8)
		return(FALSE);
	else {
		p0->x	= p.x;
		p0->y	= p.y;
		i		= i + 4;//04  15  26  37  40  51  62  73
		i		= i % 8;//POV    ̎̂QB
						//Q~U  Q  Q猩ā͂ÜʒułB
						//RST    ͂U̎璲ׂΗǂB
		return(TRUE);
	}
}

//p0̎̎̓_𒲂ׂ
BOOL MYBIT::Outside(POINT *p0, COLORREF c0, BOOL first)
{
	const	int			dx[8]={+0,-1,-1,-1,+0,+1,+1,+1};	//ɒׂ
			  		        //          E E E
	const	int			dy[8]={-1,-1,+0,+1,+1,+1,+0,-1};
					        //            
	static	int			i=0;
	POINT				p;
	int					n, w, h;
	COLORREF			*c1;

	w	= GetW();
	h	= GetH();
	if (first==TRUE) {
		//c0ɒT
		for (n=0; n<8; n++) {
			p.x			= p0->x + dx[i];
			p.y			= p0->y + dy[i];
			if (p.x<0 || p.y<0 || p.x>=w || p.y>=h)
				;
			else {
				c1		= c + (h - p.y - 1) * w + p.x;
				if ( *c1==c0 )
					break;
			}
			i			= i + 1;
			i			= i % 8;
		}
		if (n>=8)
			return(FALSE);
		i	= i + 7;//߂
	}
	//c0ȊOɒT
	for (n=0; n<8; n++) {
		i++;
		i			= i % 8;
		p.x			= p0->x + dx[i];
		p.y			= p0->y + dy[i];
		if (p.x<0 || p.y<0 || p.x>=w || p.y>=h)
			break;
		else {
			c1		= c + (h - p.y - 1) * w + p.x;
			if ( *c1!=c0 )
				break;
		}
	}
	if (n>=8)
		return(FALSE);
	else {
		p0->x	= p0->x + dx[i];
		p0->y	= p0->y + dy[i];
		i		= i + 4;	//04  15  26  37  40  51  62  73
		i		= i % 8;	//POV  U  ̎̂UB
							//Q~U    U猩ā͂Q̈ʒułB
							//RST    ͂Q̎璲ׂΗǂB
		return(TRUE);
	}
}

//90x]
void MYBIT::Rotate90(MYBIT *src)
{
	int			x1, x2, y1, y2, w1, w2, h1, h2;
	COLORREF	*c1, *c2;

	w1	= src->GetW();
	h1	= src->GetH();
	w2	= h1;
	h2	= w1;
	Resize(w2, h2);
	c1	= src->GetC();
	c2	= GetC();
	for (y1=0; y1<h1; y1++) {
		for (x1=0; x1<w1; x1++) {
			x2	= y1;
			y2	= x1;
			*(c2+y2*w2+(w2-x2-1))	= *(c1+y1*w1+x1);
		}
	}
}

//90x]
void MYBIT::Rotate90()
{
	MYBIT		temp;
	temp.Copy(this);
	Rotate90(&temp);
}

//㉺]
void MYBIT::TurnTB(MYBIT *src)
{
	int			y;
	COLORREF	*c1, *c2;

	Copy(src);
	c1	= src->GetC();
	c2	= GetC() + GetSize() - GetW();
	for (y=0; y<GetH(); y++) {
		CopyMemory(c2, c1, GetW()*4);
		c1	= c1 + GetW();
		c2	= c2 - GetW();
	}
}

//㉺]
void MYBIT::TurnTB()
{
	MYBIT		temp;
	temp.Copy(this);
	TurnTB(&temp);
}

//]]
void MYBIT::RotateTurn(MYBIT *r90, MYBIT *r180, MYBIT *r270, MYBIT *t0, MYBIT *t90, MYBIT *t180, MYBIT *t270)
{
	int			w0, w1, w2, w3, w4, w5, w6, w7;
	int			h0, h1, h2, h3, h4, h5, h6, h7;
	int			x0, x1, x2, x3, x4, x5, x6, x7;
	int			y0, y1, y2, y3, y4, y5, y6, y7;
	int			c1, c2, c3, c4, c5, c6, c7;
	COLORREF	*c0, *p0, *p1, *p2, *p3, *p4, *p5, *p6, *p7;

	w0	= GetW();
	h0	= GetH();

	w1	= h0;
	h1	= w0;

	w2	= h1;
	h2	= w1;

	w3	= h2;
	h3	= w2;

	w4	= w0;
	h4	= h0;

	w5	= w1;
	h5	= h1;

	w6	= w2;
	h6	= h2;

	w7	= w3;
	h7	= h3;

	r90 ->Resize(w1, h1);
	r180->Resize(w2, h2);
	r270->Resize(w3, h3);
	t0  ->Resize(w4, h4);
	t90 ->Resize(w5, h5);
	t180->Resize(w6, h6);
	t270->Resize(w7, h7);
	p0	= GetC();
	p1	= r90 ->GetC();
	p2	= r180->GetC();
	p3	= r270->GetC();
	p4	= t0  ->GetC();
	p5	= t90 ->GetC();
	p6	= t180->GetC();
	p7	= t270->GetC();

	for (y0=0; y0<h0; y0++) {
		for (x0=0; x0<w0; x0++) {
			c0	= p0 + ( y0 * w0 ) + x0;
			//90x]
			x1	= h0 - y0 - 1;
			y1	= x0;
			//180x]
			x2	= h1 - y1 - 1;
			y2	= x1;
			//270x]
			x3	= h2 - y2 - 1;
			y3	= x2;
			//E]
			x4	= w0 - x0 - 1;
			y4	= y0;
			//90x]㍶E]
			x5	= w1 - x1 - 1;
			y5	= y1;
			//180x]㍶E]
			x6	= w2 - x2 - 1;
			y6	= y2;
			//270x]㍶E]
			x7	= w3 - x3 - 1;
			y7	= y3;
			//AhXvZ
			c1	= ( y1 * w1 ) + x1;
			c2	= ( y2 * w2 ) + x2;
			c3	= ( y3 * w3 ) + x3;
			c4	= ( y4 * w4 ) + x4;
			c5	= ( y5 * w5 ) + x5;
			c6	= ( y6 * w6 ) + x6;
			c7	= ( y7 * w7 ) + x7;
			//Zbg
			*(p1+c1)	= *c0;
			*(p2+c2)	= *c0;
			*(p3+c3)	= *c0;
			*(p4+c4)	= *c0;
			*(p5+c5)	= *c0;
			*(p6+c6)	= *c0;
			*(p7+c7)	= *c0;
		}
	}
}

//邳߂
int MYBIT::Thick1(int x0, int y0, int thick)
{
	int			w, h, x, y, x1, y1, x2, y2, LU, RD;
	COLORREF	*c1;

	w		= GetW();
	h		= GetH();
	LU		= 0;
	RD		= 0;
	x1		= x0 - thick;
	y1		= y0 - thick;
	x2		= x0 + thick;
	y2		= y0 + thick;
	if (x1<0)	x1	= 0;
	if (y1<0)	y1	= 0;
	if (x2>=w)	x2	= w - 1;
	if (y2>=h)	y2	= h - 1;
	for (y=y1; y<=y2; y++) {
		for (x=x1; x<=x2; x++) {
			c1	= c + (h - y - 1) * w + x;
			if (*c1!=0) {
				if (x-x0+y-y0<=0)
					LU++;
				if (x-x0+y-y0>=0)
					RD++;
			}
		}
	}
	return(RD*100/(LU+RD));//0`100̒lԂ
}

//݂𖾂邳ŕ\(msk̂QoCgڂɊi[)
void MYBIT::Thick(int thick)
{
	int			x, y, w, h, i;
	COLORREF	*c1;
	int			x11, x12, x21, x22, y11, y12, y21, y22;
	COLORREF	*c11, *c12, *c21, *c22;

	w	= GetW();
	h	= GetH();
	for (y=0; y<h; y++) {
		for (x=0; x<w; x++) {
			c1	= c + (h - y - 1) * w + x;
			if (*c1!=0x00000000) {
				x11	= x - thick;
				y11	= y - thick;
				x12	= x - thick;
				y12	= y + thick;
				x21	= x + thick;
				y21	= y - thick;
				x22	= x + thick;
				y22	= y + thick;
				if (x11<0 || y11<0 || x11>=w || y11>=h ||
					x12<0 || y12<0 || x12>=w || y12>=h ||
					x21<0 || y21<0 || x21>=w || y21>=h ||
					x22<0 || y22<0 || x22>=w || y22>=h) {
					i	= Thick1(x, y, thick);
					*c1	= *c1 | (i<<16);//0`100
				}
				else {
					c11	= c + (h - y11 - 1) * w + x11;
					c12	= c + (h - y12 - 1) * w + x12;
					c21	= c + (h - y21 - 1) * w + x21;
					c22	= c + (h - y22 - 1) * w + x22;
					if (*c11!=0 && *c12!=0 && *c21!=0 && *c22!=0)
						*c1	= *c1 | (50<<16);//50
					else {
						i	= Thick1(x, y, thick);
						*c1	= *c1 | (i<<16);//0`100
					}
				}
			}
		}
	}
}

//ςƂ
void MYBIT::Average(int n)
{
	int			x, y, w, h, x1, y1, n1;
	DWORD		b1, b2, b3, b4;
	COLORREF	*c1, *c2;
	MYBIT		temp;

	temp.Copy(this);
	w	= GetW();
	h	= GetH();
	for (y=0; y<h; y++) {
		for (x=0; x<w; x++) {
			c1	= temp.GetC() + (h - y - 1) * w + x;
			if (*c1!=0x00000000) {
				b1	= 0;
				b2	= 0;
				b3	= 0;
				b4	= 0;
				n1	= 0;
				for (y1=y-n; y1<=y+n; y1++) {
					for (x1=x-n; x1<=x+n; x1++) {
						if (x1>=0 && y1>=0 && x1<w && y1<h) {
							c1	= temp.GetC() + (h - y1 - 1) * w + x1;
							if (*c1!=0x00000000) {
								b1 = b1 + (BYTE)(*c1>>24);
								b2 = b2 + (BYTE)(*c1>>16);
								b3 = b3 + (BYTE)(*c1>> 8);
								b4 = b4 + (BYTE)(*c1    );
								n1++;
							}
						}
					}
				}
				if (n1>0) {
					b1	= b1 / n1;
					b2	= b2 / n1;
					b3	= b3 / n1;
					b4	= b4 / n1;
					c2	= c + (h - y - 1) * w + x;
					*c2	= (((((b1<<8) | b2) << 8) | b3) << 8) | b4;
				}
			}
		}
	}
}

//̑傫ɂ
void MYBIT::HalfSize(MYBIT *src)
{
	COLORREF		*c1[4], *c2, col;
	int				w, h, x, y, i;
	DWORD			a, b1, b2, b3, n;

	w	= src->GetW();
	h	= src->GetH();
	if (w%2==1 || h%2==1)
		MessageBox(NULL,"c̑傫Q̐{łȂ","",MB_OK);
	Resize(w/2, h/2);
	for (y=0; y<h; y+=2) {
		for (x=0; x<w; x+=2) {
			n	= 0;
			b1	= 0;
			b2	= 0;
			b3	= 0;
			c1[0]		= src->GetC() + y * w + x;
			c1[1]		= c1[0] + 1;
			c1[2]		= c1[0] + w;
			c1[3]		= c1[2] + 1;
			for (i=0; i<4; i++) {
				col		= *(c1[i]);
				if (col!=0x00000000) {
					n++;
					b1	= b1 + (BYTE)(col>>16);
					b2	= b2 + (BYTE)(col>>8);
					b3	= b3 + (BYTE)(col);
				}
			}
			if (n>0) {
				a		= 255 * n / 4;//Alphal
				b1		= b1 / n;
				b2		= b2 / n;
				b3		= b3 / n;
				col		= (((((a<<8) | b1) << 8) | b2) << 8) | b3;
			}
			else
				col		= 0;
			c2		= c + (y/2) * (w/2) + (x/2);
			*c2		= col;
		}
	}
}

//̑傫ɂ
void MYBIT::HalfSize()
{
	MYBIT	temp;
	temp.Copy(this);
	HalfSize(&temp);
}

//imgmsk
void MYBIT::Combine(MYBIT *img, MYBIT *msk)
{
	int			i;
	COLORREF	*c1, *c2, alpha, light;
	double		L, H, S, Light;

	Copy(img);
	c1	= GetC();
	c2	= msk->GetC();
	for (i=0; i<GetSize(); i++) {
		alpha	= *c2 & 0xff000000;
		if (alpha==0)
			*c1		= 0;
		else {
			light	= (BYTE)(*c2>>16);
			if (light!=50) {
				RGBtoLHS(*c1, &L, &H, &S);
				Light	= ((double)light / 100.0) - 0.5;//-0.5`0.5
//				Light	= Light * 150.0;//-75.0`75.0
				Light	= Light * ini.edge_light;
				*c1	= LHStoRGB(L+Light, H, S);
			}
			*c1		= *c1 | alpha;
		}
		c1++;
		c2++;
	}
}

// ----------------------------------------------------------------------------------
#define PI 3.14159265358979323846

#define marume(mini, value, max)		{ \
											if ((value)<(mini)) (value) = (mini); \
											else if ((value)>(max)) (value) = (max); \
										}

double	rrr	= 0.298912;
double	ggg	= 0.586611;
double	bbb	= 0.114478;
double	sss_max	= 227.687438;

void RGBtoLHS(COLORREF rgb, double *L, double *H, double *S)
{				/*L:Lightness(Px) H:Hue(F) S:Saturation(ʓx)*/
	double	R, G, B, C1, C2;

	R	= GetBValue(rgb);//RBtɂiDIBRGBARGB֐BGRj
	G	= GetGValue(rgb);
	B	= GetRValue(rgb);//RBtɂiDIBRGBARGB֐BGRj
	*L	= R*rrr + G*ggg + B*bbb;
	C1	= R - *L;
	C2	= B - *L;
	if (C1==0)
		*H	= 0;
	else {
		*H	= atan2(C1, C2);
		*H	= *H + PI;
	}
	*S	= sqrt(C1*C1 + C2*C2);
	*L	= *L * (double)100 / (double)255;
	*H	= *H * (double)100 / (PI*(double)2);
	*S	= *S * (double)100 / sss_max;
}

COLORREF LHStoRGB(double L, double H, double S)
{
	double	R, G, B, C1, C2;

	marume(0, L, 100)
	marume(0, S, 100)
	marume(0, H, 100)
	L	= L * (double)255 / (double)100;
	H	= H * (PI*(double)2) / (double)100;
	H	= H - PI;
	S	= S * sss_max / (double)100;
	C1	= S * sin(H);
	C2	= S * cos(H);
	R	= L + C1;
	G	= L - C1 * rrr / ggg  -  C2 * bbb / ggg;
	B	= L + C2;
	marume(0, R, 255)
	marume(0, G, 255)
	marume(0, B, 255)
	return(RGB((DWORD)B, (DWORD)G, (DWORD)R));//RBtɂiDIBRGBARGB֐BGRj
}

COLORREF LHStoRGBx(double L, double H, double S)
{
	double	R, G, B, C1, C2;

	marume(0, L, 100)
	marume(0, S, 100)
	marume(0, H, 100)
	L	= L * (double)255 / (double)100;
	H	= H * (PI*(double)2) / (double)100;
	H	= H - PI;
	S	= S * sss_max / (double)100;
	C1	= S * sin(H);
	C2	= S * cos(H);
	R	= L + C1;
	G	= L - C1 * rrr / ggg  -  C2 * bbb / ggg;
	B	= L + C2;
	marume(0, R, 255)
	marume(0, G, 255)
	marume(0, B, 255)
	return(RGB((DWORD)R, (DWORD)G, (DWORD)B));
}

