#ifndef _MYBIT_H_
#define _MYBIT_H_

#include <windows.h>
#include "bzline.h"

#define max(a, b)  (((a) > (b)) ? (a) : (b))
#define min(a, b)  (((a) < (b)) ? (a) : (b))

#define MSGBOX(a) {\
					char s[1000];\
					wsprintf a ;\
					MessageBox(NULL,s,"",MB_OK);\
				}

#ifdef _MYBIT_CPP_
BOOL trace_flg=FALSE;
#else
extern	BOOL trace_flg;
void trace(char *str);
#endif

#ifdef _TRACE_OFF_
#define TRACE(a)
#else
#define TRACE(a) {\
					if (trace_flg==TRUE) {\
						char s[1000];\
						wsprintf a ;\
						trace(s);\
					}\
				}
#endif

void		RGBtoLHS(COLORREF rgb, double *L, double *H, double *S);
COLORREF	LHStoRGB(double L, double H, double S);
COLORREF	LHStoRGBx(double L, double H, double S);

class MYBIT
{
	BITMAPFILEHEADER	bf;
	BITMAPINFOHEADER	bh;
	COLORREF			*c;
	int					size;	//Frbg
private:
	BOOL		Hosei		(MYBIT *dst, int *dst_x, int *dst_y, MYBIT *src, int *src_x, int *src_y, int *w, int *h);
	BOOL		Load_Image	(char *fname, HINSTANCE hInstance);
	int			Thick1		(int x0, int y0, int thick);
public:
	MYBIT();
	~MYBIT();
	void		Reset		();
	BOOL		ReadDIB		(char *fname, HINSTANCE hInstance, int jpeg_denom=1);
	BOOL		ReadDIBS	(char *fname, HINSTANCE hInstance, int size);//͌AӂsizeɊgk
	BOOL		ReadWH		(char *fname, HINSTANCE hInstance, int *w, int *h);//width,height𒲂ׂ
	void		WriteDIB	(char *fname);
	void		CutDesktop	(int x, int y, int w, int h);				//fXNgbvʂ̈ꕔ؂
	void		Display		(int x, int y, HWND hWnd);					//hWndx,ÿʒuɕ\
	void		Display		(int x, int y, HDC hDC);					//hDCx,ÿʒuɕ\
	void		Cut			(MYBIT *src, int x, int y, int w, int h);	//src̈ꕔ؂
	void		FillB		(int x, int y, COLORREF c1, COLORREF c2);	//c1œhԂ c2͋E
	void		FillB		(POINT p, COLORREF c1, COLORREF c2) {FillB(p.x, p.y, c1, c2);};
	void		FillS		(int x, int y, COLORREF c1, COLORREF c2);	//c1œhԂ c2u
	void		BZline		(BZ *bzt, COLORREF c1);						//c1ŃxWGȐ
	void		Line		(int x0, int y0, int x1, int y1, COLORREF c1);		//c1Œ
	void		Stretch		(MYBIT *src, int w, int h);					//w,h̑傫ɂ
	void		Stretch		(int w, int h);								//w,h̑傫ɂ
	void		Text		(char *str, RECT r, COLORREF tx=RGB(0,0,0), COLORREF bk=RGB(255,255,255));//\
	void		Copy		(MYBIT *src);								//srcRs[
	void		Clear		(COLORREF color);							//wFœhԂ
	void		Clear		(COLORREF color, int w, int h);				//w̑傫ōč쐬ēhԂ
	void		Resize		(int w, int h);
	void		Paste		(MYBIT *src, int x, int y);					//x,ÿʒusrc\t
	void		PasteA		(MYBIT *src, int x, int y);					//x,ÿʒusrc\tiAlphauhj
	void		PasteA		(MYBIT *src, POINT p)	{PasteA(src, p.x, p.y);};
	BOOL		Equal		(MYBIT *buf);
	BOOL		Find		(MYBIT *buf);								//buf܂܂Ă邩
	void		OR			(COLORREF color);
	void		AND			(COLORREF color);
	BOOL		Inside		(POINT *p0, COLORREF c0);
	BOOL		Outside		(POINT *p0, COLORREF c0, BOOL first);
	void		Rotate90	(MYBIT *src);
	void		Rotate90	();
	void		TurnTB		(MYBIT *src);
	void		TurnTB		();
	void		RotateTurn	(MYBIT *r90, MYBIT *r180, MYBIT *r270, MYBIT *t0, MYBIT *t90, MYBIT *t180, MYBIT *t270);
	void		Thick		(int thick);
	void		Average		(int n);
	void		HalfSize	(MYBIT *src);
	void		HalfSize	();
	void		Combine		(MYBIT *img, MYBIT *msk);

	int			GetW		() { return(bh.biWidth); };
	int			GetH		() { return(bh.biHeight); };
	int			GetSize		() { return(size); };
	void		SetSize		(int sz) { size=sz; };
	COLORREF*	GetC		() { return(c); };
	void		SetC		(COLORREF* cp) { c=cp; };
	BITMAPFILEHEADER*	GetBf		() { return(&bf); };
	BITMAPINFOHEADER*	GetBh		() { return(&bh); };
};

#endif /*_MYBIT_H_*/

