

#define _TRACE_OFF_


#include <windows.h>
#include <math.h>
#include "mybit.h"
#include "prog.h"
#include "piece.h"
#include "desk.h"

extern HWND			main_hWnd;
extern DESK			DK;

PIECE::PIECE()
{
	rect.left			= 0;
	rect.top			= 0;
	rect.right			= 0;
	rect.bottom			= 0;
	muki				= 0;
	joint				= 0;
	tonari				= NULL;
	org_rect.left		= 0;
	org_rect.top		= 0;
	org_rect.right		= 0;
	org_rect.bottom		= 0;
}

PIECE::~PIECE()
{
	Reset();
}

void PIECE::Reset()
{
	int		i;

	for (i=0; i<8; i++) {
		img[i].Reset();
	}
	rect.left			= 0;
	rect.top			= 0;
	rect.right			= 0;
	rect.bottom			= 0;
	muki				= 0;
	joint				= 0;
	if (tonari!=NULL)
		GlobalFree(tonari);
	tonari			= NULL;
	org_rect.left		= 0;
	org_rect.top		= 0;
	org_rect.right		= 0;
	org_rect.bottom		= 0;
}

PIECES::PIECES()
{
	int		i;

	num			= 0;
	for (i=0; i<10000; i++) {
		order[i]	= -1;
	}
}

PIECES::~PIECES()
{
	Reset();
}

void PIECES::Reset()
{
	int		i;

	num			= 0;
	for (i=0; i<10000; i++) {
		piece[i].Reset();
		order[i] = -1;
	}
	desk		= DK.GetDeskPtr();
	back		= DK.GetBackPtr();
}

int PIECES::SelCheck(POINT mouse)
{
	MYBIT		*pimg;
	int			i, j, w, h, x, y;
	RECT		r;
	COLORREF	*c1;

	for (i=num-1; i>=0; i--) {
		j			= order[i];
		pimg		= &(piece[j].img[ piece[j].muki ]);
		w			= pimg->GetW();
		h			= pimg->GetH();
		r			= piece[j].rect;
		if (mouse.x>r.left && mouse.y>r.top && mouse.x<r.right && mouse.y<r.bottom) {
			x		= mouse.x - r.left;
			y		= mouse.y - r.top;
			c1		= pimg->GetC() + (h - y - 1) * w + x;
			if (*c1!=0)
				return(i);//ordeṙԂ
		}
	}
	return(-1);
}

int PIECES::Select(int no)		//noorder̔ԍ
{
	int			i, j, k, jno, mk=-1, no_save;
	RECT		r1;
	int			wk[10000];

	//Is[X(no)jointT
	jno	= piece[ order[no] ].joint;
	//Is[XȊOW߂
	j	= 0;
	for (i=0; i<num; i++) {
		k	= order[i];
		if (piece[k].joint != jno) {
			wk[j]	= order[i];
			mk		= j;
			j++;
		}
	}
	//Is[XɏW߂
	for (i=0; i<num; i++) {
		k	= order[i];
		if (piece[k].joint == jno) {
			wk[j]	= order[i];
			if (i==no)
				no_save	= j;//order[no]wk[no_save]Ɉړ
			j++;
		}
	}
	//orderɖ߂
	for (i=0; i<num; i++) {
		order[i]	= wk[i];
	}
	//Is[Xĕ\
	for (i=mk+1; i<num; i++) {
		r1	= BackClear(i);
		Display(r1, 0, num-1);
	}
	return(no_save);
}

//ŏʃs[Ẍړ
void PIECES::Move(int dx, int dy)
{
	RECT		r1;
	int			i, mk=-1, jno;

	//ŏʃs[XjointT
	jno	= piece[ order[num-1] ].joint;
	//ŏʃs[XT
	for (i=0; i<num; i++) {
		if (piece[ order[i] ].joint==jno)
			break;
		mk	= i;
	}
	//ړÔƂɈړs[XȊO\
	for (i=mk+1; i<num; i++) {
		r1	= BackClear(i);
		Display(r1, 0, mk);
	}
	//ŏʃs[X̍Wړ
	for (i=0; i<num; i++) {
		if (piece[i].joint==jno) {
			piece[i].rect.left		+= dx;
			piece[i].rect.top		+= dy;
			piece[i].rect.right		+= dx;
			piece[i].rect.bottom	+= dy;
		}
	}
	//ړ̂ƂɈړs[X\
	for (i=mk+1; i<num; i++) {
		r1	= piece[ order[i] ].rect;
		Display(r1, mk+1, num-1);
	}
}

//s[X̓ړ
void PIECES::MMove(POINT from, POINT to)
{
	RECT		r1, r2;
	int			i, j, k, l, m, jno[10], dx, dy;
	double		a;

	//Iʒủ̃s[XPO܂ōT
	j	= 0;
	for (i=0; i<num; i++) {
		r1	= piece[ order[num-i] ].rect;
		r1.left		-= 20;
		r1.right	+= 20;
		r1.top		-= 20;
		r1.bottom	+= 20;
		if (r1.left < from.x && from.x < r1.right &&
			r1.top  < from.y && from.y < r1.bottom) {
			l	= piece[ order[num-i] ].joint;
			for (k=0; k<j; k++) {
				if (jno[k]==l)	break;
			}
			if (k>=j) {
				jno[j++]	= l;
				if (j>=10)	break;
			}
		}
	}
	//pno[i]Ɠjoint̃s[Xړ
	dx			= to.x - from.x;
	dy			= to.y - from.y;
	r1.left		= 0;
	r1.right	= 0;
	r2.left		= 0;
	r2.right	= 0;
	for (i=0; i<num; i++) {
		l	= order[i];
		a	= 1.0;
		for (k=0; k<j; k++) {
			if (jno[k]==piece[l].joint) {
				if (r1.left==r1.right) {
					r1	= piece[l].rect;
				}
				else {
					if (piece[l].rect.left   < r1.left)			r1.left		= piece[l].rect.left;
					if (piece[l].rect.right  > r1.right)		r1.right	= piece[l].rect.right;
					if (piece[l].rect.top    < r1.top)			r1.top		= piece[l].rect.top;
					if (piece[l].rect.bottom > r1.bottom)		r1.bottom	= piece[l].rect.bottom;
				}
				BackClear(i);
				piece[l].rect.left		+= (int)((double)dx * a);
				piece[l].rect.top		+= (int)((double)dy * a);
				piece[l].rect.right		+= (int)((double)dx * a);
				piece[l].rect.bottom	+= (int)((double)dy * a);
				if (r2.left==r2.right) {
					r2	= piece[l].rect;
				}
				else {
					if (piece[l].rect.left   < r2.left)			r2.left		= piece[l].rect.left;
					if (piece[l].rect.right  > r2.right)		r2.right	= piece[l].rect.right;
					if (piece[l].rect.top    < r2.top)			r2.top		= piece[l].rect.top;
					if (piece[l].rect.bottom > r2.bottom)		r2.bottom	= piece[l].rect.bottom;
				}
				break;
			}
			a	= a * 0.8;
		}
	}
	//ړ͈͂̑Ss[X\
	Display(r1, 0, num-1);
	Display(r2, 0, num-1);
}

int PIECES::Rotate(int no, POINT mouse, BYTE button)		//noorder̔ԍ
{
	int			jno, i, j, mk=-1;
	RECT		r1;

	//Is[X(no)jointT
	jno	= piece[ order[no] ].joint;
	//ŏʃs[XT
	for (i=0; i<num; i++) {
		j	= order[i];
		if (piece[j].joint==jno)
			break;
		mk	= i;
	}
	//]ÔƂɉ]s[XȊO\
	for (i=mk+1; i<num; i++) {
		r1	= BackClear(i);
		Display(r1, 0, mk);
	}
	//s[X̉]
	for (i=0; i<num; i++) {
		if (piece[i].joint==jno) {
			Rotate2(i, mouse, button);
		}
	}
	//]\
	for (i=mk+1; i<num; i++) {
		j	= order[i];
		r1	= piece[j].rect;
		Display(r1, mk+1, num-1);
	}
	return(no);
}

void PIECES::Rotate2(int i, POINT mouse, BYTE button)
{
	if (button==0x80) {//WM_LBUTTONDOWN
		if (piece[i].muki<4)
			piece[i].muki	= (piece[i].muki + 1) % 4;//
		else
			piece[i].muki	= (piece[i].muki - 4 + 3) % 4 + 4;
		OffsetRect(&piece[i].rect, -mouse.x, -mouse.y);
		piece[i].rect			 = Rotate_R(piece[i].rect, 1);
		OffsetRect(&piece[i].rect, +mouse.x, +mouse.y);
	}
	else
	if (button==0x40) {//WM_RBUTTONDOWN
		if (piece[i].muki<4)
			piece[i].muki	= (piece[i].muki + 3) % 4;//E
		else
			piece[i].muki	= (piece[i].muki - 4 + 1) % 4 + 4;
		OffsetRect(&piece[i].rect, -mouse.x, -mouse.y);
		piece[i].rect			 = Rotate_R(piece[i].rect, 3);
		OffsetRect(&piece[i].rect, +mouse.x, +mouse.y);
	}
	else {
		piece[i].muki	= (piece[i].muki + 4) % 8;//]
		OffsetRect(&piece[i].rect, -mouse.x, -mouse.y);
		piece[i].rect			 = Rotate_R(piece[i].rect, 4);
		OffsetRect(&piece[i].rect, +mouse.x, +mouse.y);
	}
}

POINT PIECES::Rotate_XY(POINT xy, int muki)
{
	int		i, j;
	POINT	p;

	i	= muki % 4;
	for (j=0; j<i; j++) {
		p.x		=   xy.y;
		p.y		= - xy.x;
		xy		= p;
	}
	if (muki>3)
		xy.x	= - xy.x;
	return(xy);
}

RECT PIECES::Rotate_R(RECT r0, int muki)
{
	int		i, j;
	RECT	r1;

	i	= muki % 4;
	for (j=0; j<i; j++) {
		r1.left		=   r0.top;
		r1.top		= - r0.right;
		r1.right	=   r0.bottom;
		r1.bottom	= - r0.left;
		r0			= r1;
	}
	if (muki>3) {
		r1.left		= - r0.right;
		r1.right	= - r0.left;
		r1.top		=   r0.top;
		r1.bottom	=   r0.bottom;
		r0			= r1;
	}
	return(r0);
}

BOOL PIECES::JointCheck()
{
	int			i, j, k, ii, mk=-1, dx1, dx2, dy1, dy2, dx3, dy3, jno, new_jno;
	char		tt[10000];
	int			dx, dy;
	int			wk[10000];
	BOOL		rc=FALSE;
	RECT		r1, r2;

	ii		= order[num-1];
	jno		= piece[ii].joint;

	ZeroMemory(tt,sizeof(tt));
	ZeroMemory(wk,sizeof(wk));
	//ׂł΂P}[N
	for (i=0; i<num; i++) {
		if (piece[i].joint == jno) {
			for (j=0; piece[i].tonari[j]!=-1; j++) {
				k		= piece[i].tonari[j];
				tt[k]	= 1;
			}
		}
	}
	//WCg\ׂ
	for (i=0; i<num; i++) {
		if (piece[i].joint != jno) {
			//Ⴄ
			if (piece[i].muki != piece[ii].muki)
				continue;
			//ׂłȂ
			if (tt[i]==0)
				continue;
			//vZ
			dx1		= piece[i].rect.left - piece[ii].rect.left;	//݂̂
			dy1		= piece[i].rect.top  - piece[ii].rect.top;
			r1		= Rotate_R(piece[i ].org_rect, piece[i ].muki);
			r2		= Rotate_R(piece[ii].org_rect, piece[ii].muki);
			dx2		= r1.left - r2.left;						//{̂
			dy2		= r1.top  - r2.top;
			dx		= dx1 - dx2;
			dy		= dy1 - dy2;
			dx3		= (dx < 0) ? - dx : dx;
			dy3		= (dy < 0) ? - dy : dy;
			//UhbgȏジĂ
			if (dx3>6 || dy3>6)
				continue;
			//WCgł
			new_jno		= piece[i].joint;
			rc			= TRUE;
			break;
		}
	}

	if (rc==FALSE)
		return(rc);

	//WCgs[XȊOW߂
	j	= 0;
	for (i=0; i<num; i++) {
		k	= order[i];
		if (piece[k].joint != jno && piece[k].joint != new_jno) {
			wk[j]	= order[i];
			mk		= j;
			j++;
		}
	}
	//WCgs[XɏW߂
	for (i=0; i<num; i++) {
		k	= order[i];
		if (piece[k].joint == jno || piece[k].joint == new_jno) {
			wk[j]	= order[i];
			j++;
		}
	}
	//orderɖ߂
	for (i=0; i<num; i++) {
		order[i]	= wk[i];
	}
	//WCgs[X
	for (i=mk+1; i<num; i++) {
		r1	= BackClear(i);
		Display(r1, 0, mk);
	}
	//ړ
	for (i=0; i<num; i++) {
		if (piece[i].joint == jno) {
			piece[i].rect.left		+= dx;
			piece[i].rect.top		+= dy;
			piece[i].rect.right		+= dx;
			piece[i].rect.bottom	+= dy;
			piece[i].joint			=  new_jno;
		}
	}
	//WCgs[X\
	for (i=mk+1; i<num; i++) {
		j	= order[i];
		r1	= piece[j].rect;
		Display(r1, mk+1, num-1);
	}
	return(rc);
}

//}EXʒũs[X؂藣
void PIECES::Separate(int odr)
{
	int		i, j, k, l, max_joint, sv_no, sv_joint, from, to;
	RECT	r1;
	int		work[10000];
	char	sw  [10000];

	ZeroMemory(work,sizeof(work));
	ZeroMemory(sw  ,sizeof(sw  ));
	//joint̍őlT
	max_joint	= -1;
	for (i=0; i<num; i++) {
		if (max_joint<piece[i].joint) {
			max_joint	= piece[i].joint;
		}
	}
	//؂藣s[XɈړ
	sv_no				= order[odr];
	sv_joint			= piece[sv_no].joint;
	piece[sv_no].joint	= ++max_joint;		//؂藣ijointԍ̔ԁj
	for (i=odr; i<num-1; i++) {
		order[i]	= order[i+1];
	}
	order[num-1]	= sv_no;
	//O[v̎n܂ƏIT
	from	= -1;
	to		= -1;
	for (i=0; i<num; i++) {
		if (piece[order[i]].joint==sv_joint) {
			from	= i;
			work[i]	= -1;
			for (; i<num; i++) {
				if (piece[order[i]].joint==sv_joint) {
					to		= i;
					work[i]	= -1;
				}
			}
			break;
		}
	}
	//fromto܂łO[viדmłȂ̂ʃO[vɂj
	if (from<to) {
		i	= from;//דmT_
		k	= from;//דmi[ʒu
		while (i<=to) {
			if (work[i]==-1) {										//O[v̂Pڂi[ĂȂ
				for (j=from; j<=to; j++) {							//i[ł̂T
					if (sw[j]==0) {									//i[ĂȂ
						sw[j]	= 1;								//i[
						work[k]	= order[j];							//i[
						piece[work[k]].joint = ++max_joint;			//WCgԍ͐Vɍ̔
						k++;
						break;
					}
				}
			}
			for (j=from; j<=to; j++) {								//דmT
				if (sw[j]==0) {										//i[ĂȂ
					for (l=0; piece[work[i]].tonari[l]!=-1; l++) {
						if (piece[work[i]].tonari[l]==order[j]) {	//דmł
							work[k]	= order[j];						//i[
							sw  [j]	= 1;							//i[
							piece[work[k]].joint = max_joint;		//WCgԍ͓̂Zbg
							k++;
							break;
						}
					}
				}
			}
			i++;
		}
		for (i=from; i<=to; i++) {
			order[i]	= work[i];
		}
	}
	//؂藣s[XȊO\
	r1	= BackClear(num-1);
	Display(r1, 0, num-2);
	//؂藣s[X̍Wړ
	piece[sv_no].rect.left		+= 5;
	piece[sv_no].rect.top		+= 5;
	piece[sv_no].rect.right		+= 5;
	piece[sv_no].rect.bottom	+= 5;
	//ړ̂Ƃɐ؂藣s[X\
	Display(piece[sv_no].rect, num-1, num-1);
}

RECT PIECES::BackClear(int odr)
{
	int		j, w1, h1;
	RECT	r1;
	MYBIT	*pimg, temp;

	j			= order[odr];
	pimg		= &(piece[j].img[ piece[j].muki ]);
	r1			= piece[j].rect;
	w1			= pimg->GetW();
	h1			= pimg->GetH();
	temp.Cut(back, r1.left, r1.top, w1, h1);
	if (r1.left<0)
		r1.left	= 0;
	if (r1.top<0)
		r1.top	= 0;
	desk->Paste(&temp, r1.left, r1.top);
	TRACE((s,"PIECES::BackClear(END) no=%d left=%d top=%d right=%d bottom=%d", no,r1.left,r1.top,r1.right,r1.bottom))
	return(r1);
}

void PIECES::Display(RECT r1, int from_no, int to_no)		//noorder̔ԍ
{
	int		i, j, w3, h3, x3, y3;
	RECT	r2, r3;
	MYBIT	*pimg, temp;

	if (from_no<0)
		from_no		= 0;
	if (to_no>=num)
		to_no		= num - 1;
	for (i=from_no; i<=to_no; i++) {
		j			= order[i];
		r2			= piece[j].rect;
		TRACE((s,"PIECES::Dislpay i=%d", i))
		TRACE((s,"PIECES::Dislpay r1.left=%d r1.top=%d r1.right=%d r1.bottom=%d",r1.left,r1.top,r1.right,r1.bottom))
		TRACE((s,"PIECES::Dislpay r2.left=%d r2.top=%d r2.right=%d r2.bottom=%d",r2.left,r2.top,r2.right,r2.bottom))
		IntersectRect(&r3, &r1, &r2);
		if (r3.left!=0 || r3.top!=0 || r3.right!=0 || r3.bottom!=0) {
			TRACE((s,"PIECES::Dislpay(then) r3.left=%d r3.top=%d r3.right=%d r3.bottom=%d",r3.left,r3.top,r3.right,r3.bottom))
			w3		= r3.right  - r3.left;
			h3		= r3.bottom - r3.top;
			if (r1.left>r2.left)
				x3	= r1.left - r2.left;
			else
				x3	= 0;
			if (r1.top>r2.top)
				y3	= r1.top - r2.top;
			else
				y3	= 0;
			pimg	= &(piece[j].img[ piece[j].muki ]);
			temp.Cut(pimg, x3, y3, w3, h3);
			desk->PasteA(&temp, r3.left, r3.top);
		}
		else {
			TRACE((s,"PIECES::Dislpay(else) r3.left=%d r3.top=%d r3.right=%d r3.bottom=%d",r3.left,r3.top,r3.right,r3.bottom))
		}
	}
}

void PIECES::Random(int no, BOOL kaiten, BOOL hanten, HWND hWnd)
{
	static BOOL		sran=FALSE;
	RECT			r;
	int				i, w, h;

	if (sran==FALSE) {
		srand(GetTickCount());
		sran	= TRUE;
	}
	GetClientRect(hWnd, &r);
	piece[no].rect.left	= ( rand() % ( (r.right/2)-100 ) ) + 50;
	piece[no].rect.top	= ( rand() % ( (r.bottom )-100 ) ) + 50;
	if (kaiten==TRUE) {
		if (hanten==TRUE)
			piece[no].muki	= rand() % 8;
		else
			piece[no].muki	= rand() % 4;
	}
	else {
		if (hanten==TRUE) {
			if ((rand()%2)==0)
				piece[no].muki	= 0;
			else
				piece[no].muki	= 4;
		}
	}
	piece[no].joint	= no;
	i	= piece[no].muki;
	w	= piece[no].img[i].GetW();
	h	= piece[no].img[i].GetH();
	piece[no].rect.right	= piece[no].rect.left + w;
	piece[no].rect.bottom	= piece[no].rect.top  + h;
}

void PIECES::RandomOdr(int odr, BOOL kaiten, BOOL hanten, HWND hWnd)
{
	Random(order[odr], kaiten, hanten, hWnd);
}

void PIECES::Seiretu(int no)
{
	piece[no].joint	= no;
	piece[no].muki	= 0;
	piece[no].rect	= piece[no].org_rect;
}

void PIECES::Save(char *fname, MYBIT *img, int *yukou_num, int *elap)	//fo
{
	DWORD	dwResult;
	int		i, j, sz, cur_num;

	DeleteFile(fname);
	HANDLE hF = CreateFile(fname, GENERIC_WRITE, 0, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);

	//IWi摜C[Wbmp`ŏo
	WriteFile(hF, img->GetBf(), sizeof(BITMAPFILEHEADER), &dwResult, NULL);
	WriteFile(hF, img->GetBh(), sizeof(BITMAPINFOHEADER), &dwResult, NULL);
	sz	= img->GetSize();
	WriteFile(hF, &sz, sizeof(int), &dwResult, NULL);
	WriteFile(hF, img->GetC(), sz*4, &dwResult, NULL);

	//ݐo
	cur_num		= GetCurNum();
	WriteFile(hF, &cur_num, sizeof(int), &dwResult, NULL);
	//Lo
	WriteFile(hF, yukou_num, sizeof(int), &dwResult, NULL);
	//oߎԂo
	WriteFile(hF, elap, sizeof(int), &dwResult, NULL);

	//s[Xo
	WriteFile(hF, &num, sizeof(int), &dwResult, NULL);
	//es[Xo
	for (i=0; i<num; i++) {
		for (j=0; j<8; j++) {
			WriteFile(hF, piece[i].img[j].GetBf(), sizeof(BITMAPFILEHEADER), &dwResult, NULL);
			WriteFile(hF, piece[i].img[j].GetBh(), sizeof(BITMAPINFOHEADER), &dwResult, NULL);
			sz	= piece[i].img[j].GetSize();
			WriteFile(hF, &sz, sizeof(int), &dwResult, NULL);
			WriteFile(hF, piece[i].img[j].GetC(), sz*4, &dwResult, NULL);
		}
		WriteFile(hF, &piece[i].rect, sizeof(RECT), &dwResult, NULL);
		WriteFile(hF, &piece[i].muki, sizeof(int), &dwResult, NULL);
		WriteFile(hF, &piece[i].joint, sizeof(int), &dwResult, NULL);
		j	= 0;
		while (piece[i].tonari[j]!=-1) {
			WriteFile(hF, &piece[i].tonari[j], sizeof(int), &dwResult, NULL);
			j++;
		}
		j	= -1;
		WriteFile(hF, &j, sizeof(int), &dwResult, NULL);
		WriteFile(hF, &piece[i].org_rect, sizeof(RECT), &dwResult, NULL);
		WriteFile(hF, &order[i], sizeof(int), &dwResult, NULL);
	}

	CloseHandle(hF);
}

int PIECES::Load(char *fname, MYBIT *img, int *yukou_num, int *elap)	//f
{
	DWORD		dwResult;
	int			i, j, sz, cur_num;
	COLORREF	*cp;
	int			tt[10000], ttnum, *ttp;

	Reset();
	HANDLE hF = CreateFile(fname, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);

	//IWi摜C[W
	img->Reset();
	ReadFile(hF, img->GetBf(), sizeof(BITMAPFILEHEADER), &dwResult, NULL);
	ReadFile(hF, img->GetBh(), sizeof(BITMAPINFOHEADER), &dwResult, NULL);
	ReadFile(hF, &sz, sizeof(int), &dwResult, NULL);
	img->SetSize(sz);
	cp	= (COLORREF*)GlobalAlloc(GMEM_FIXED, sz*4);
	ReadFile(hF, cp, sz*4, &dwResult, NULL);
	img->SetC(cp);

	//ݐ
	ReadFile(hF, &cur_num, sizeof(int), &dwResult, NULL);
	//L
	ReadFile(hF, yukou_num, sizeof(int), &dwResult, NULL);
	//oߎԂ
	ReadFile(hF, elap, sizeof(int), &dwResult, NULL);

	//s[X
	ReadFile(hF, &num, sizeof(int), &dwResult, NULL);
	//es[X
	for (i=0; i<num; i++) {
		for (j=0; j<8; j++) {
			ReadFile(hF, piece[i].img[j].GetBf(), sizeof(BITMAPFILEHEADER), &dwResult, NULL);
			ReadFile(hF, piece[i].img[j].GetBh(), sizeof(BITMAPINFOHEADER), &dwResult, NULL);
			ReadFile(hF, &sz, sizeof(int), &dwResult, NULL);
			piece[i].img[j].SetSize(sz);
			cp	= (COLORREF*)GlobalAlloc(GMEM_FIXED, sz*4);
			ReadFile(hF, cp, sz*4, &dwResult, NULL);
			piece[i].img[j].SetC(cp);
		}
		ReadFile(hF, &piece[i].rect, sizeof(RECT), &dwResult, NULL);
		ReadFile(hF, &piece[i].muki, sizeof(int), &dwResult, NULL);
		ReadFile(hF, &piece[i].joint, sizeof(int), &dwResult, NULL);
		ttnum	= 0;
		while (1) {
			ReadFile(hF, &tt[ttnum], sizeof(int), &dwResult, NULL);
			if (tt[ttnum]==-1)
				break;
			ttnum++;
		}
		ttnum++;
		ttp	= (int*)GlobalAlloc(GMEM_FIXED, ttnum*4);
		CopyMemory (ttp, tt, ttnum*4);
		SetTonari(i, ttp);
		ReadFile(hF, &piece[i].org_rect, sizeof(RECT), &dwResult, NULL);
		ReadFile(hF, &order[i], sizeof(int), &dwResult, NULL);
	}
	CloseHandle(hF);
	return(cur_num);
}

int GetYukouNum(char *fname, int *cur_num)	//fĹiview.cppŎgpAPIECESNXɓĂȂj
{
	DWORD		dwResult;
	int			sz, yukou;
	MYBIT		img;
	COLORREF	*cp;

	HANDLE hF = CreateFile(fname, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	//IWi摜C[W
	img.Reset();
	ReadFile(hF, img.GetBf(), sizeof(BITMAPFILEHEADER), &dwResult, NULL);
	ReadFile(hF, img.GetBh(), sizeof(BITMAPINFOHEADER), &dwResult, NULL);
	ReadFile(hF, &sz, sizeof(int), &dwResult, NULL);
	img.SetSize(sz);
	cp	= (COLORREF*)GlobalAlloc(GMEM_FIXED, sz*4);
	ReadFile(hF, cp, sz*4, &dwResult, NULL);
	img.SetC(cp);
	//ݐ
	ReadFile(hF, cur_num, sizeof(int), &dwResult, NULL);
	//L
	ReadFile(hF, &yukou, sizeof(int), &dwResult, NULL);
	CloseHandle(hF);
	return(yukou);
}

int PIECES::GetCurNum()	//݂̗L𐔂
{
	int		i, j, n, jn;
	
	n	= 0;
	jn	= -1;
	for (i=0; i<num; i++) {
		j	= order[i];
		if ((piece[j].org_rect.right  - piece[j].org_rect.left)>2 ||	//ȃs[X
			(piece[j].org_rect.bottom - piece[j].org_rect.top )>2) {	//O
			if (piece[j].joint!=jn) {
				n++;
				jn	= piece[j].joint;
			}
		}
	}
	return(n);
}

void PIECES::GetEndImg(MYBIT *image, RECT *r)
{
	int		i;

	r->left		= 99999;
	r->top		= 99999;
	r->right	= -99999;
	r->bottom	= -99999;
	for (i=0; i<num; i++) {
		if ((piece[i].org_rect.right  - piece[i].org_rect.left)>2 ||	//ȃs[X
			(piece[i].org_rect.bottom - piece[i].org_rect.top )>2) {	//O
			r->left		= min(r->left,   piece[i].rect.left);
			r->top		= min(r->top,    piece[i].rect.top);
			r->right	= max(r->right,  piece[i].rect.right);
			r->bottom	= max(r->bottom, piece[i].rect.bottom);
		}
	}
	image->Cut(desk, r->left, r->top, (r->right)-(r->left), (r->bottom)-(r->top));
}

void PIECES::AddRect(int dx, int dy, int from, int to)
{
	int		i;

	for (i=from; i<=to; i++) {
		piece[i].rect.left   -= dx;
		piece[i].rect.top    -= dy;
		piece[i].rect.right  -= dx;
		piece[i].rect.bottom -= dy;
	}
}

